//---------------------------------------------------------------------------
//
//	CMatrixMan.cpp	s񉉎Z̋SƂ͉̂Ƃ@}gbNX}NX
//
//                  }gbNX}͌vZGɂȂgkAsړA
//                  ]Ȃǂ̊evZs񉉎ZŃXpƂĂ̂邷
//                  B}gbNX}ɗ߂΁AD݂̊e
//                  sĂ̂ňSB
//                  3DIuWFNg肭Ǝv}gbNX}
//                  ǂȂ̂Ԃ̋ߓȁB
//
//	Programmed by Mikio Kusaka With Microsoft Visual C++ 6.0
//
//@^u͂SɂĂ
//---------------------------------------------------------------------------
// wb_[CN[h 
//---------------------------------------------------------------------------
#include <math.h>
#include "CMatrixMan.h"
//---------------------------------------------------------------------------
// Cvg 
//---------------------------------------------------------------------------
CMatrixMan4::CMatrixMan4()
{

	//RXgN^
	
	//Pʍsŏ
	Initialize();

}
//---------------------------------------------------------------------------
CMatrixMan4::CMatrixMan4(CMatrixMan4 &m)
{

	//Rs[RXgN^

	m00 = m.m00;	m01 = m.m01;	m02 = m.m02;	m03 = m.m03;
	m10 = m.m10;	m11 = m.m11;	m12 = m.m12;	m13 = m.m13;
	m20 = m.m20;	m21 = m.m21;	m22 = m.m22;	m23 = m.m23;
	m30 = m.m30;	m31 = m.m31;	m32 = m.m32;	m33 = m.m33;
		
}
//---------------------------------------------------------------------------
CMatrixMan4::CMatrixMan4(CVectorMan3 &v)
{

	//Rs[RXgN^̂Q

	//Pʍsŏ
	Initialize();

	//Wl𖄂ߍ
	m00 = v.x; m11 = v.y;	m22 = v.z; m33 = 1.0f;

}
//---------------------------------------------------------------------------
CMatrixMan4::~CMatrixMan4()
{

	//fXgN^

}
//---------------------------------------------------------------------------
void CMatrixMan4::Initialize()
{

	//Pʍsŏ
	
	//PʍsƂ͂
	//| 1 0 0 0 |
	//| 0 1 0 0 |
	//| 0 0 1 0 |
	//| 0 0 0 1 |
	
	m00 = 1.0f;	m01 = 0.0f;	m02 = 0.0f;	m03 = 0.0f;
	m10 = 0.0f;	m11 = 1.0f;	m12 = 0.0f;	m13 = 0.0f;
	m20 = 0.0f;	m21 = 0.0f;	m22 = 1.0f;	m23 = 0.0f;
	m30 = 0.0f;	m31 = 0.0f;	m32 = 0.0f;	m33 = 1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::Scale(float sx,float sy,float sz)
{

	//XP[ϊs̍쐬
	//Wn

	//XP[ϊsƂ͂
	//sx,sy,sz͂ꂼ̎ł̊g嗦
	//| sx  0  0  0 |
	//|  0 sy  0  0 |
	//|  0  0 sz  0 | 
	//|  0  0  0  1 |

	m00 = sx;	m01 = 0.0f;	m02 = 0.0f;	m03 = 0.0f;
	m10 = 0.0f;	m11 = sy;	m12 = 0.0f;	m13 = 0.0f;
	m20 = 0.0f;	m21 = 0.0f;	m22 = sz;	m23 = 0.0f;
	m30 = 0.0f;	m31 = 0.0f;	m32 = 0.0f;	m33 = 1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::RotateX(float rx)
{

	//w]s̍쐬
	//Wn

	float sinx = (float)sin(rx);
	float cosx = (float)cos(rx);	

	//w]sƂ͂
	//| 1     0    0    0 |
	//| 0  cosX sinX    0 |
	//| 0 -sinX cosX    0 |
	//| 0     0    0    1 |	

	m00 = 1.0f;	m01 = 0.0f; m02 = 0.0f; m03 = 0.0f;
	m10 = 0.0f; m11 = cosx; m12 = sinx; m13 = 0.0f;
	m20 = 0.0f; m21 =-sinx; m22 = cosx; m23 = 0.0f;
	m30 = 0.0f; m31 = 0.0f;	m32 = 0.0f; m33 = 1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::RotateY(float ry)
{

	//x]s̍쐬
	//Wn

	float siny = (float)sin(ry);
	float cosy = (float)cos(ry);

	//x]sƂ͂
	//| cosY   0 -sinY    0 |
	//|    0   1     0    0 |
	//| sinY   0  cosY    0 |
	//|    0   0     0    1 |

	m00 = cosy; m01 = 0.0f; m02 =-siny; m03 = 0.0f;
	m10 = 0.0f; m11 = 1.0f; m12 = 0.0f; m13 = 0.0f;
	m20 = siny; m21 = 0.0f; m22 = cosy; m23 = 0.0f;
	m30 = 0.0f; m31 = 0.0f; m32 = 0.0f; m33 = 1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::RotateZ(float rz)
{
	
	//y]s̍쐬
	//Wn

	float sinz = (float)sin(rz);
	float cosz = (float)cos(rz);	

	//y]sƂ͂
	//|  cosZ sinZ   0   0 |
	//| -sinZ cosZ   0   0 |
	//|     0    0   1   0 |
	//|     0    0   0   1 |	

	m00 = cosz; m01 = sinz; m02 = 0.0f; m03 = 0.0f;
	m10 =-sinz; m11 = cosz; m12 = 0.0f; m13 = 0.0f;
	m20 = 0.0f; m21 = 0.0f; m22 = 1.0f; m23 = 0.0f;
	m30 = 0.0f; m31 = 0.0f; m32 = 0.0f; m33 = 1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::Translate(float dx,float dy,float fZ)
{

	//sړs̍쐬
	//Wn

	//sړsƂ͂
	//|  1  0  0  0 |
	//|  0  1  0  0 |
	//|  0  0  1  0 |
	//| dx dy fZ  1 |

	m00 = 1.0f; m01 = 0.0f; m02 =  0.0f; m03 = 0.0f;
	m10 = 0.0f; m11 = 1.0f; m12 =  0.0f; m13 = 0.0f;
	m20 = 0.0f; m21 = 0.0f; m22 =  1.0f; m23 = 0.0f;
	m30 =   dx; m31 =   dy; m32 =    fZ; m33 = 1.0f;

}
//---------------------------------------------------------------------------		
void CMatrixMan4::Invert(CMatrixMan4 &m)
{

	//]us̍쐬
	//m00m33ԑΊpɔ]

	m00 = m.m00; m01 = m.m10; m02 = m.m20; m03 = 0.0f;
	m10 = m.m01; m11 = m.m11; m12 = m.m21; m13 = 0.0f;
	m20 = m.m02; m21 = m.m12; m22 = m.m22; m23 = 0.0f;
	m30 =  0.0f; m31 =  0.0f; m32 =  0.0f; m33 = 1.0f;
	
}
//---------------------------------------------------------------------------
void CMatrixMan4::View(CVectorMan3 &from,CVectorMan3 &at,CVectorMan3 &ue)
{

	//r[ϊs̍쐬
	//IuWFNgJ猩ʒu֕ϊ邽߂̍s
	
	//form	Ji_j̈ʒu
	//at	_
	//ue	J̏
	//Wn
	CVectorMan3 vecX;		//XxNg
	CVectorMan3 vecY;		//YxNg
	CVectorMan3 vecZ;		//ZxNg

	// s ZxNg擾B
    // _璍_܂ł̍łB
    //  (ʏ+Z) łB
    
	//Ji_j璍_܂ł̃xNgZo
	vecZ = at - from;	//xNgvZ
	
	vecZ.Normalize();	//PʃxNg

	// (ZxNg) J̏\uexNg
	// ̊Oς璼XxNg(ʏ+X)ZoAX
	// xNgZxNgƂ̊OςɂAX-ZʂɒY
	// xNg(ʏ+Y)𓱂܂B
    
	vecX.CrossProduct(ue,vecZ);			//O
	vecX.Normalize();					//PʃxNg
	vecY.CrossProduct(vecZ,vecX);		//O
	vecY.Normalize();					//PʃxNg
	
	// s̍\zJnBŏ 3 ̍sɂ́A
    // r[]Ē_Ɍ邽߂̃xNg܂܂B
    // point.
	// 4Ԗڂ̍sɂ͕sړ̒l(ẽxNgfromƂ̓)
	// ܂܂B 
    // _𒆐SƂ]sB
    //
	//| vecX.x        vecY.x        vecZ.x        0 |	]
	//| vecX.y        vecY.y        vecZ.z        0 |	]
	//| vecX.z        vecY.y        vecZ.z        0 |	]
	//| -(vecXEfrom) -(vecYEfrom) -(vecZEfrom) 1 |	sړ

	//sɓĂ͂߂
	m00 = vecX.x;	m01 =  vecY.x;	m02 = vecZ.x;	m03 = 0.0f;
	m10 = vecX.y;	m11 =  vecY.y;	m12 = vecZ.y;	m13 = 0.0f;
	m20 = vecX.z;	m21 =  vecY.z;	m22 = vecZ.z;	m23 = 0.0f;
	m30 = -(from.DotProduct(vecX));
	m31 = -(from.DotProduct(vecY));
	m32 = -(from.DotProduct(vecZ));
	m33 =  1.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::Projection(float Near,float Far,float fov,float aspect)
{

	//vWFNVs̍쐬
	//ȒPɌƁAJɋ߂̂͑傫Â͏s

	//ˉes
	//fov		piWAPʁj
	//aspect	XN[̃AXyNg
	//Near		_XN[܂ł̋
	//Far		_王ĚE܂ł̋
	//Wn

	float w = aspect * (float)cos(fov * 0.5f) / (float)sin(fov * 0.5f);
	float h = 1.0f   * (float)cos(fov * 0.5f) / (float)sin(fov * 0.5f);
	float q = Far / (Far - Near);

	//| w   0   0         0 |
	//| 0   h   0         0 |
	//| 0   0   q         1 |
	//| 0   0   -q * Near 0 |

	Initialize();
	
	m00 = w;
	m11 = h;
	m22 = q;
	m23 = 1.0f;
	m32 = -q * Near;
	m33 = 0.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::Projection2(float Near,float Far,float fov_h,float fov_v)
{

	//vWFNVs̍쐬̂Q
	//ȒPɌƁAJɋ߂̂͑傫Â͏s

	//ˉes
	//Near		_XN[܂ł̋
	//Far		_王ĚE܂ł̋
	//fov_h		̎piWAPʁj
	//fov_v		̎piWAPʁj
	//Wn

 	float w = (1.0f / (float)tan(fov_h * 0.5f));	// 1/tan(x) == cot(x)
	float h = (1.0f / (float)tan(fov_v * 0.5f));	// 1/tan(x) == cot(x)
	float q = Far / (Far - Near);

	//| w   0   0         0 |
	//| 0   h   0         0 |
	//| 0   0   q         1 |
	//| 0   0   -q * Near 0 |

	Initialize();
	
	m00 = w;
	m11 = h;
	m22 = q;
	m23 = 1.0f;
	m32 = -q * Near;
	m33 = 0.0f;

}
//---------------------------------------------------------------------------
void CMatrixMan4::Clip(float ClipX,float ClipY,float ClipWidth,float ClipHeight,
				   float MinZ,float MaxZ)
{

	//NbsOs̍쐬

	Initialize();
	
	m00 = 1.0f / ClipWidth;
	m11 = 1.0f / ClipHeight;
	m22 = 1.0f / (MaxZ - MinZ);
	m30 = -ClipX / ClipWidth;
	m31 = -ClipY / ClipHeight;
	m32 = -MinZ / (MaxZ - MinZ);
	
}
//---------------------------------------------------------------------------
void CMatrixMan4::ViewPort(float fX,float fY,float fWidth,float fHeight)
{

	//r[|[gs̍쐬

	//̍śAr[|[g̐@юw̐[x͈͂ɏ]
	//_XP[OA̒__O ^[Qbg
	//T[tFX̓K؂ȈʒuWɕsړB܂A̍śA
	//y ɑ鍶p̃XN[_𔽉f邽߂ 
	//y W𔽓]B̍sKpA_͓łB
	//܂A_͈ˑRƂ [x,y,z,w] _Ƃđ݂̂ŁA
	//X^CUɑOɒ_񓯎ɃgXtH[Ȃ
	//΂ȂȂB
	//iDirectX8.0{wv蔲j
	
	//| Width / 2		0				0			0 |	XW̃XP[O
	//| 0				-Height / 2		0			0 |	YW̃XP[O㉺]
	//| 0				0				1			0 | ZW͂̂܂
	//| X + Width / 2	Height / 2 + Y	0			1 |	_ʂ̒Sɕsړ

	Initialize();
	
	m00 = fWidth / 2.0f;
	m11 = -fHeight / 2.0f;
	m30 = fX + fWidth / 2.0f;
	m31 = fHeight / 2.0f + fY;

}
//---------------------------------------------------------------------------
CMatrixMan4 CMatrixMan4::operator + (CMatrixMan4 &m)
{

	//s񓯎m̉Z
	CMatrixMan4 mm;

	mm.m00 = m00 + m.m00;
	mm.m01 = m01 + m.m01;
	mm.m02 = m02 + m.m02;
	mm.m03 = m03 + m.m03;
	
	mm.m10 = m10 + m.m10;
	mm.m11 = m11 + m.m11;
	mm.m12 = m12 + m.m12;
	mm.m13 = m13 + m.m13;

	mm.m20 = m20 + m.m20;
	mm.m21 = m21 + m.m21;
	mm.m22 = m22 + m.m22;
	mm.m23 = m23 + m.m23;

	mm.m30 = m30 + m.m30;
	mm.m31 = m31 + m.m31;
	mm.m32 = m32 + m.m32;
	mm.m33 = m33 + m.m33;

	return mm;
	
}
//---------------------------------------------------------------------------
CMatrixMan4 CMatrixMan4::operator - (CMatrixMan4 &m)
{

	//s񓯎m̌Z
	CMatrixMan4 mm;

	mm.m00 = m00 - m.m00;
	mm.m01 = m01 - m.m01;
	mm.m02 = m02 - m.m02;
	mm.m03 = m03 - m.m03;
	
	mm.m10 = m10 - m.m10;
	mm.m11 = m11 - m.m11;
	mm.m12 = m12 - m.m12;
	mm.m13 = m13 - m.m13;

	mm.m20 = m20 - m.m20;
	mm.m21 = m21 - m.m21;
	mm.m22 = m22 - m.m22;
	mm.m23 = m23 - m.m23;

	mm.m30 = m30 - m.m30;
	mm.m31 = m31 - m.m31;
	mm.m32 = m32 - m.m32;
	mm.m33 = m33 - m.m33;

	return mm;
	
}
//---------------------------------------------------------------------------
CMatrixMan4 CMatrixMan4::operator * (CMatrixMan4 &m)
{

	//s񓯎m̏Z
	CMatrixMan4 mm;

	float _00 = m00 * m.m00 + m01 * m.m10 + m02 * m.m20 + m03 * m.m30;
	float _01 = m00 * m.m01 + m01 * m.m11 + m02 * m.m21 + m03 * m.m31;
	float _02 = m00 * m.m02 + m01 * m.m12 + m02 * m.m22 + m03 * m.m32;
	float _03 = m00 * m.m03 + m01 * m.m13 + m02 * m.m23 + m03 * m.m33;

	float _10 = m10 * m.m00 + m11 * m.m10 + m12 * m.m20 + m13 * m.m30;
	float _11 = m10 * m.m01 + m11 * m.m11 + m12 * m.m21 + m13 * m.m31;
	float _12 = m10 * m.m02 + m11 * m.m12 + m12 * m.m22 + m13 * m.m32;
	float _13 = m10 * m.m03 + m11 * m.m13 + m12 * m.m23 + m13 * m.m33;
		
	float _20 = m20 * m.m00 + m21 * m.m10 + m22 * m.m20 + m23 * m.m30;
	float _21 = m20 * m.m01 + m21 * m.m11 + m22 * m.m21 + m23 * m.m31;
	float _22 = m20 * m.m02 + m21 * m.m12 + m22 * m.m22 + m23 * m.m32;
	float _23 = m20 * m.m03 + m21 * m.m13 + m22 * m.m23 + m23 * m.m33;
		
	float _30 = m30 * m.m00 + m31 * m.m10 + m32 * m.m20 + m33 * m.m30;
	float _31 = m30 * m.m01 + m31 * m.m11 + m32 * m.m21 + m33 * m.m31;
	float _32 = m30 * m.m02 + m31 * m.m12 + m32 * m.m22 + m33 * m.m32;
	float _33 = m30 * m.m03 + m31 * m.m13 + m32 * m.m23 + m33 * m.m33;
		
	mm.m00 = _00;	mm.m01 = _01;	mm.m02 = _02;	mm.m03 = _03;
	mm.m10 = _10;	mm.m11 = _11;	mm.m12 = _12;	mm.m13 = _13;
	mm.m20 = _20;	mm.m21 = _21;	mm.m22 = _22;	mm.m23 = _23;
	mm.m30 = _30;	mm.m31 = _31;	mm.m32 = _32;	mm.m33 = _33;

	return mm;

}
//---------------------------------------------------------------------------
